JUCE: GenericScopedUnlock< LockType > Class Template Reference

JUCE

Public Member Functions | List of all members
GenericScopedUnlock< LockType > Class Template Reference
juce_core » threads

Automatically unlocks and re-locks a mutex object. More...

`#include <juce_ScopedLock.h>`

## Public Member Functions
| GenericScopedUnlock (const LockType &lock) noexcept
| Creates a GenericScopedUnlock. More...
| ~GenericScopedUnlock () noexcept
| Destructor. More...

## Detailed Description

template<class LockType>
class GenericScopedUnlock< LockType >

Automatically unlocks and re-locks a mutex object.

This is the reverse of a GenericScopedLock object - instead of locking the mutex for the lifetime of this object, it unlocks it.

Make sure you don't try to unlock mutexes that aren't actually locked!

e.g.

CriticalSection myCriticalSection;
for (;;)
{
const GenericScopedLock<CriticalSection> myScopedLock (myCriticalSection);
// myCriticalSection is now locked
... do some stuff with it locked ..
while (xyz)
{
... do some stuff with it locked ..
const GenericScopedUnlock<CriticalSection> unlocker (myCriticalSection);
// myCriticalSection is now unlocked for the remainder of this block,
// and re-locked at the end.
...do some stuff with it unlocked ...
}
// myCriticalSection gets unlocked here.
}
CriticalSection
A re-entrant mutex.
Definition: juce_CriticalSection.h:44
GenericScopedLock
Automatically locks and unlocks a mutex object.
Definition: juce_ScopedLock.h:56
GenericScopedUnlock
Automatically unlocks and re-locks a mutex object.
Definition: juce_ScopedLock.h:127

See also
  GenericScopedLock, CriticalSection, ScopedLock, ScopedUnlock

## Constructor & Destructor Documentation

## ◆ GenericScopedUnlock()

template<class LockType >

GenericScopedUnlock< LockType >::GenericScopedUnlock | ( | const LockType & | lock | ) |
| explicitnoexcept

Creates a GenericScopedUnlock.

As soon as it is created, this will unlock the CriticalSection, and when the ScopedLock object is deleted, the CriticalSection will be re-locked.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen! Best just to use it as a local stack object, rather than creating one with the new() operator.

## ◆ ~GenericScopedUnlock()

template<class LockType >

GenericScopedUnlock< LockType >::~GenericScopedUnlock | ( |  | ) |
| noexcept

Destructor.

The CriticalSection will be unlocked when the destructor is called.

Make sure this object is created and deleted by the same thread, otherwise there are no guarantees what will happen!

The documentation for this class was generated from the following file:

- juce_ScopedLock.h